(function() {
  var allocate, compute_layout, find_obstacle, intersection, intersection_segment, next;
  intersection_segment = function(a1, a2, b1, b2) {
    if (a1 <= b1) {
      return a2 > b1;
    } else {
      return b2 > a1;
    }
  };
  intersection = function(A, B) {
    return (intersection_segment(A.x, A.x + A.w, B.x, B.x + B.w)) && (intersection_segment(A.y, A.y + A.h, B.y, B.y + B.h));
  };
  next = function(position, obstacle) {
    if (position.x >= 0) {
      if (position.x >= position.y) {
        return position.y = Math.max(position.y, obstacle.y + obstacle.h, position.y + 1);
      } else {
        return position.x = Math.min(position.x - 1, obstacle.x - position.w);
      }
    } else {
      position.x = position.y;
      return position.y = 0;
    }
  };
  find_obstacle = function(layout, position) {
    var k, obstacle;
    for (k in layout) {
      obstacle = layout[k];
      if (intersection(position, obstacle)) {
        return obstacle;
      }
    }
    return null;
  };
  allocate = function(layout, box) {
    var obstacle, position;
    position = {
      x: 0,
      y: 0,
      w: box.w,
      h: box.h
    };
    obstacle = find_obstacle(layout, position);
    while (obstacle != null) {
      next(position, obstacle);
      if (position.x >= 0 && position.y >= 0) {
        obstacle = find_obstacle(layout, position);
      }
    }
    return position;
  };
  compute_layout = function(image_dimensions) {
    var box, boxs, h, img, layout, w, _i, _len;
    layout = {};
    boxs = (function() {
      var _ref, _results;
      _results = [];
      for (img in image_dimensions) {
        _ref = image_dimensions[img], w = _ref[0], h = _ref[1];
        _results.push({
          img: img,
          w: w,
          h: h
        });
      }
      return _results;
    })();
    boxs.sort(function(obj) {
      return -obj.w;
    });
    for (_i = 0, _len = boxs.length; _i < _len; _i++) {
      box = boxs[_i];
      layout[box.img] = allocate(layout, box);
    }
    return layout;
  };
  module.exports.compute_layout = compute_layout;
}).call(this);
