intersection_segment = (a1,a2,b1,b2)->
    if (a1<=b1)
        # a1 [-----[ a2
        #    b1 [-----[ b2
        a2>b1
    else
        #   a1 [-----[ a2
        # b1 [-----[ b2
        b2>a1

    
intersection = (A, B)->
    # A and B being boxes, 
    # returns true if A ∩ B ≠ ∅
    ( intersection_segment A.x, (A.x+A.w), B.x, (B.x+B.w) ) and
    ( intersection_segment A.y, (A.y+A.h), B.y, (B.y+B.h)  )


next = (position,obstacle)->
    # move the considered position to the next
    # position to be considered
    if position.x >= 0
        if position.x>=position.y
            # we try to try down
            position.y = Math.max position.y, obstacle.y+obstacle.h,position.y+1
        else
            # we try to go left
            position.x = Math.min position.x-1, obstacle.x-position.w
    else
        position.x = position.y
        position.y = 0

        
find_obstacle = (layout,position)->
    # Loop on all already placed box
    # and returns any intersecting box.
    for k,obstacle of layout
        if intersection position,obstacle
            return obstacle
    null


allocate = (layout, box)->
    # given an already 
    position = 
        x:0
        y:0
        w:box.w
        h:box.h
    obstacle = find_obstacle layout, position
    while obstacle?
        next position,obstacle
        if position.x >= 0 and position.y >= 0
            obstacle = find_obstacle layout, position
    position


compute_layout = (image_dimensions)->
    # Returns a layout for all the pictures
    layout = {}
    boxs = ( {img:img, w:w, h:h}  for img,[w,h] of image_dimensions )
    boxs.sort (obj)->-obj.w   
    for box in boxs
        layout[box.img] = allocate layout, box
    layout

module.exports.compute_layout = compute_layout